
/* Define on Darwin to activate all library features */
#define _DARWIN_C_SOURCE 1
/* This must be set to 64 on some systems to enable large file support. */
#define _FILE_OFFSET_BITS 64
/* Define on Linux to activate all library features */
#define _GNU_SOURCE 1
/* This must be defined on some systems to enable large file support. */
#define _LARGEFILE_SOURCE 1
/* Define on NetBSD to activate all library features */
#define _NETBSD_SOURCE 1
/* Define to activate features from IEEE Stds 1003.1-2001 */
#ifndef _POSIX_C_SOURCE
#  define _POSIX_C_SOURCE 200112L
#endif
/* Define on FreeBSD to activate all library features */
#define __BSD_VISIBLE 1
#define __XSI_VISIBLE 700
/* Windows: winsock/winsock2 mess */
#define WIN32_LEAN_AND_MEAN
#ifdef _WIN64
   typedef          __int64 Signed;
   typedef unsigned __int64 Unsigned;
#  define SIGNED_MIN LLONG_MIN 
#else
   typedef          long Signed;
   typedef unsigned long Unsigned;
#  define SIGNED_MIN LONG_MIN
#endif

/* using ShadowStackFrameworkGCTransformer */
#define MALLOC_ZERO_FILLED 1
#include <Python.h>
#include <src/thread.h>
#include <stdlib.h>
#include <src/signals.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <errno.h>
#include <stdio.h>
#include <src/stacklet/stacklet.h>
#include <src/stack.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <utime.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <src/dtoa.h>
#include <sys/utsname.h>
#include <sys/statvfs.h>
#include <dlfcn.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/evp.h>
#include <openssl/ossl_typ.h>
#include <openssl/x509v3.h>
#include <time.h>
#include <string.h>
#include <assert.h>
#include <locale.h>
#include <limits.h>
#include <ctype.h>
#include <wchar.h>
#include <langinfo.h>
#include <libintl.h>
#include <semaphore.h>
#include <expat.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdint.h>
#include <netpacket/packet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <src/cjkcodecs/multibytecodec.h>
#include <bzlib.h>
#include <zlib.h>
#include <pwd.h>
#include <sys/timeb.h>
#include <sys/resource.h>
#include <sys/file.h>
#include <termios.h>
#include <ffi.h>
#include <sys/epoll.h>
#include <curses.h>
#include <term.h>
#include <stdarg.h>
int get_errno ();
void set_errno (int v);
int pypy_macro_wrapper_WCOREDUMP (int status);
int pypy_macro_wrapper_WIFCONTINUED (int status);
int pypy_macro_wrapper_WIFSTOPPED (int status);
int pypy_macro_wrapper_WIFSIGNALED (int status);
int pypy_macro_wrapper_WIFEXITED (int status);
int pypy_macro_wrapper_WEXITSTATUS (int status);
int pypy_macro_wrapper_WSTOPSIG (int status);
int pypy_macro_wrapper_WTERMSIG (int status);
#define pypy_GENERAL_NAME_dirn(name) (name->d.dirn)
int _PyPy_SSL_SetupThreads(void);

static float pypy__uint2singlefloat(unsigned int x) {
    float ff;
    assert(sizeof(float) == 4 && sizeof(unsigned int) == 4);
    memcpy(&ff, &x, 4);
    return ff;
}
static unsigned int pypy__singlefloat2uint(float x) {
    unsigned int ii;
    assert(sizeof(float) == 4 && sizeof(unsigned int) == 4);
    memcpy(&ii, &x, 4);
    return ii;
}

char ** get_environ ();
void set_environ (char ** v);
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>
#include <sys/select.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdint.h>
#include <errno.h>
#include <netpacket/packet.h>
#include <sys/ioctl.h>
#include <net/if.h>

#ifdef AF_NETLINK
#include <linux/netlink.h>
#endif

int _noprof_execve(char *filename, char *argv[], char *envp[]);
int _noprof_execv(char *path, char *argv[]);
pid_t _noprof_fork(void);

#define pypy__is_nonnull_longdouble(x)  ((x) != 0.0)

#define DOUBLE_IS_LITTLE_ENDIAN_IEEE754

#include "src/dtoa.c"
